#ifndef __CALLBACKS_H
#define __CALLBACKS_H

#ifndef HAVE_GNOME
void thunk(gpointer data, guint function, GtkWidget *item);
enum {
   SEARCH_DOWNLOAD_CB,
   BROWSE_USER_MENU_CB,
   WHOIS_USER_MENU_CB,
   BROWSE_DOWNLOAD_CB,
   RETRY_DOWNLOAD_CB,
   CANCEL_DOWNLOAD_CB,
   CANCEL_REMOVE_CB,
   CANCEL_UPLOAD_CB,
   FORCE_QUEUE_CB,
   CANCEL_QUEUE_CB,
   MOVEQUEUE_CB
};

typedef void (*GnomeReplyCallback)(gint reply, gpointer data);

#endif /* !HAVE_GNOME */

void browse_clear(GtkWidget *);
int property_notify(GtkWidget *, GdkEventProperty *, void *);
GList *add_nick_history(GList *, char *);
void safe_exit_check();
void safe_exit_cb();
void gnapster_exit_cb();
void update_xtext(GtkWidget *);
void browse_font_ok_cb(GtkWidget *, GtkWidget *);
void browse_font_cancel_cb(GtkWidget *, GtkWidget *);
void browse_font_cb();
void refresh_dlg_cb(GtkWidget *, void *);
void already_connected(Server *);
void connect_last_cb();
void already_connected_cb(gint, gpointer);
void update_shares_cb();
void connect_official_cb();
void switch_page_cb(GtkWidget *, GtkNotebookPage *, int, gpointer);
void build_list_cb();
void update_list_cb();
void query_user_cb(GtkWidget *, gpointer);
void unquery_user_cb(GtkWidget *, gpointer);
void menu_popup_cb();
void console_activate_cb();
int console_keypress_cb();
Search *get_data(const void *);
User *get_user_data(const void *);
int compare_chan_user(GtkCList *, const void *, const void *);
int compare_chan_conn(GtkCList *, const void *, const void *);
int compare_chan_shares(GtkCList *, const void *, const void *);
void channel_sort(GtkCList *, int);
int compare_file(GtkCList *, const void *, const void *);
int compare_user(GtkCList *, const void *, const void *);
int compare_size(GtkCList *, const void *, const void *);
int compare_length(GtkCList *, const void *, const void *);
int compare_bitrate(GtkCList *, const void *, const void *);
int compare_connection(GtkCList *, const void *, const void *);
void search_sort(GtkCList *, int);
void end_search(char *);
void cancel_search_cb();
void search_activate_cb();
void browse_user_menu(GtkWidget *);
void browse_user_menu_cb(GtkWidget *, gpointer);
void browse_user_cb();
void whois_user_menu_cb(GtkWidget *, gpointer);
void connect_cb();
void disconnect_cb();
void search_download_cb(GtkWidget *, gpointer);
void browse_download_cb(GtkWidget *, gpointer);
void search_queue_cb(GtkWidget *, gpointer);
void browse_queue_cb(GtkWidget *, gpointer);
void queue_true_cb(GtkWidget *, gpointer);
void start_queue_cb();
void stop_queue_cb();
void cancel_upload_cb();
char *listint_to_str(int, int);
int liststr_to_int(char *);
void combo_changed(GtkWidget *, gpointer);
void preferences_changed_cb();
#ifdef HAVE_GNOME
void preferences_button_cb(GtkWidget *, gint, gpointer);
#else
void preferences_button_cb(GtkWidget *, gpointer);
#endif /* HAVE_GNOME */
void preferences_destroy_cb(GtkWidget *, gint, gpointer);
void clicked_cb(GtkWidget *, int *);
void preferences_clicked_cb(GtkWidget *, int *);
void preferences_cb();
void build_dlg_cancel_cb();
void about_cb();

#endif /* __CALLBACKS_H */
