#ifndef __COMMAND_H
#define __COMMAND_H

typedef void (*GCommand) (char *command, char *args);

#define COMMAND(x) void x (char *command, char *args)

typedef struct _command {
   char *command;
   GCommand func;
   char *syntax;
   char *help;
} Command;

void invalid_args(char *);
int handle_command(char *, char *);
COMMAND(do_sendtext);
COMMAND(do_help);
COMMAND(do_version);
COMMAND(do_wallop);
COMMAND(do_global);
COMMAND(do_topic);
COMMAND(do_clear);
COMMAND(do_sv);
COMMAND(do_whois);
COMMAND(do_msg);
COMMAND(do_me);
COMMAND(do_query);
COMMAND(do_ignore);
COMMAND(do_unignore);
COMMAND(do_join);
COMMAND(do_part);
COMMAND(do_raw);
COMMAND(do_kill);
COMMAND(do_kick);
COMMAND(do_ban);
COMMAND(do_unban);
COMMAND(do_muzzle);
COMMAND(do_unmuzzle);
COMMAND(do_mode);
COMMAND(do_setport);
COMMAND(do_userlevel);
COMMAND(do_setline);
COMMAND(do_links);
COMMAND(do_signore);
COMMAND(do_unsignore);
COMMAND(do_sigsave);
COMMAND(do_share);
COMMAND(do_stats);
COMMAND(do_chanlevel);
COMMAND(do_usermode);
COMMAND(do_op);
COMMAND(do_deop);
COMMAND(do_ops);
COMMAND(do_cbans);
COMMAND(do_cban);
COMMAND(do_cunban);
COMMAND(do_cunban_all);
COMMAND(do_bans);
COMMAND(do_load);
COMMAND(do_reload);
COMMAND(do_nuke);
COMMAND(do_hook);

#endif /* __COMMAND_H */
