#ifndef __DEBUG_H
#define __DEBUG_H

void d_warning(const char *, int, char *, char *, void *);
void d_trace(const char *, int, char *);
void *d_memory_hunk_append(const char *, int, void *, unsigned int);
char *d_config_get_string(const char *, int, const char *);
void *d_hunk_add(const char *, int, void *, unsigned int);
void *d_new(const char *, int, int);
void *d_malloc(const char *, int, unsigned int);
void *d_realloc(const char *, int, void *, unsigned int);
void *d_calloc(const char *, int, unsigned int);
char *d_strdup_vprintf(const char *, int, const char *s, va_list args);
char *d_str_expand(const char *, int, char *, const char *, ...);
char *d_strdup_printf(const char *, int, const char *s, ...);
void *d_free(const char *, int, void *ptr);
int d_strcmp(const char *, const char *);
char *d_strdup(const char *, int, const char *s);
void d_summary();

#define DEBUG __FILE__,__LINE__,
#define DEBUG_TRACE() d_trace(DEBUG __PRETTY_FUNCTION__);

#define read_file(x) read_file(DEBUG x)
#define read_file_with_n(x) read_file_with_n(DEBUG x)
#define d_config_get_string(x) d_config_get_string(DEBUG x)
#define d_hunk_add(x,y) d_hunk_add(DEBUG x,y)
#define d_new(x) d_new(DEBUG x)
#define d_malloc(x) d_malloc(DEBUG x)
#define d_realloc(x,y) d_realloc(DEBUG x,y)
#define d_calloc(x) d_calloc(DEBUG x)
#define d_strdup_vprintf(x,y) d_strdup_vprintf(DEBUG x,y)
//#define d_strdup_printf(x) d_strdup_printf(x,__FILE__,__LINE__)
#define d_free(x) d_free(DEBUG x)
#define d_strdup(x) d_strdup(DEBUG x)

#endif /* __DEBUG_H */
