//#include <gtk/gtk.h>

#ifndef __UI_H
#define __UI_H

#ifdef HAVE_GNOME
#define DIALOG_YES GNOME_YES
#define DIALOG_NO GNOME_NO
#else
#define DIALOG_YES 1
#define DIALOG_NO 0
#endif /* HAVE_GNOME */

#define j_box_pack(b,w,x,y,z) \
        gtk_box_pack_start(GTK_BOX(b),w,x,y,z)

typedef struct {
   int type;
   char *conf;
   int key;
   GList *sensitive;
} WidgetProperty;

typedef struct {
   GtkWidget *window;
   GtkWidget *notebook;
   GtkWidget *appbar;
#ifndef HAVE_GNOME
   GtkWidget *vbox;
   GtkWidget *menubar;
#endif
   GtkProgress *progress;
   GtkStyle *normal;
   GtkStyle *highlight;
   int appbar_timeout;
} GnapsterMain;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *entry;
   GtkWidget *not_label;
   GtkWidget *not_entry;
   GtkWidget *gtk_entry;
   GtkWidget *gtk_not_entry;
   GtkWidget *search_btn;
   GtkWidget *cancel_btn;
   GtkWidget *list_btn;
   GtkWidget *line_speed_switch;
   GtkWidget *line_speed;
   GtkWidget *line_speed_cmp;
   GtkWidget *bitrate_switch;
   GtkWidget *bitrate;
   GtkWidget *bitrate_cmp;
   GtkWidget *local_only;
   GtkWidget *clist;
   GtkWidget *scroller;
} SearchTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *entry;
   GtkWidget *list_btn;
   GtkWidget *clear_btn;
   GtkWidget *scroller;
   GtkWidget *ctree;
} BrowseTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *max_downloads_switch;
   GtkWidget *max_downloads;
   GtkWidget *max_peruser_downloads_switch;
   GtkWidget *max_peruser_downloads;
   GtkWidget *clist;
   GtkWidget *queue_clist;
   GtkWidget *start_queue;
   GtkWidget *stop_queue;
   GtkWidget *queue_label;
   GtkWidget *scroller;
   GtkWidget *autocancel;
} DownloadTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *max_uploads_switch;
   GtkWidget *max_uploads;
   GtkWidget *max_peruser_uploads_switch;
   GtkWidget *max_peruser_uploads;
   GtkWidget *clist;
   GtkWidget *scroller;
} UploadTab;

typedef struct {
   GtkWidget *main_vbox;
   GtkWidget *notebook;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *entry;
   GList *channel_list;
   GtkWidget *links_map;
} ConsoleTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *scroller2;
   GtkWidget *hide_list;
   GtkWidget *clist;
   char *channel;
} ChannelTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
} MOTDTab;

typedef struct {
   GtkWidget *window;
   GtkWidget *frame;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *new_user;
   GtkWidget *nap_port;
   GtkWidget *user_entry;
   GtkWidget *pass_entry;
   GtkWidget *connection;
   GtkWidget *download_dir;
   GtkWidget *upload_dir;
   GtkWidget *build_list;
   GtkWidget *update_list;
   GtkWidget *autoquery;
   GtkWidget *name_fix;
   GtkWidget *hide_joinpart;
   GtkWidget *hide_users;
   GtkWidget *theme_colors;
   GtkWidget *auto_rm;
   GtkWidget *opennap_server;
   GtkWidget *server_entry;
   GtkWidget *auto_start_queue;
   GtkWidget *reject_ul;
   GtkWidget *firewall;
   GtkWidget *socks_firewall;
   GtkWidget *socks_server;
   GtkWidget *socks_port;
   GtkWidget *socks4;
   GtkWidget *socks5;
   GtkWidget *socks5_username;
   GtkWidget *socks5_password;
   GtkWidget *aj_entry;
   GtkWidget *aj_add;
   GtkWidget *aj_remove;
   GtkWidget *aj_clist;
   GtkWidget *logging;
   GtkWidget *font_entry;
   GtkWidget *font_browse;
   GtkWidget *trans;
   GtkWidget *update_tint;
   GtkWidget *tint_red, *tint_green, *tint_blue;
   GtkWidget *curr_theme;
   GtkWidget *themes;
   int calling;
#ifndef HAVE_GNOME
   GtkWidget *notebook;
#endif
   GtkWidget *scroller;
} PropDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   int pipe_input;
   int cpid;
} BuildDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *ctree;
   GtkWidget *ctree_mem;
   GtkWidget *clist;
   GtkWidget *add;
   GtkWidget *edit;
   GtkWidget *delete;
   GtkWidget *show_network;
   int show_network_id;
   GtkWidget *refresh;
   GtkWidget *trefresh;
   GtkWidget *scroller;
} BrowseDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
} RefreshDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *server;
   GtkWidget *port;
   GtkWidget *desc;
   GtkWidget *network;
} EditDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *server;
   GtkWidget *port;
   GtkWidget *desc;
   GtkWidget *network;
} AddDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *scroller;
   GtkWidget *clist;
} ListChanDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *scroller;
   GtkWidget *clist;
} ResumeDlg;

/* prototypes */
void set_green_style(GtkWidget *w, int row, int col);
void configure_event(GtkWidget *w, GdkEventConfigure *e, GtkWidget *text);
int dialog_open(GtkWidget *window);
GtkWidget *j_line_new(GtkWidget *w, int i1, int i2);
GtkWidget *j_combo_new(int type, ...);
GtkWidget *create_gnapster_tab(char *label, char *stock);
void create_gnapster_main();
void create_search_tab();
void create_browse_tab();
GList *browse_breakdown_path(Search *browse, GList *elem);
void browse_tab_find(GtkCTreeNode **last, GtkCTreeNode *node, GList *ptr, int *l);
void browse_tab_add(Search *browse);
void create_download_tab();
void create_upload_tab();
void create_console_tab();
void unhook_configure(GtkWidget *w, void *data);
void append_console_tab(char *channel_name, int user);
int remove_console_tab(char *data, int user);
void create_motd_tab();
void create_prop_dlg(void *changed_cb, void *button_cb, void *destroy_cb, void *clicked_cb, int *new_user_val);
void create_build_dlg();
void create_browse_dlg();
void create_refresh_dlg();
void create_add_dlg();
void create_edit_dlg(Server *nsrv, char *desc);
void create_list_chan_dlg();
void create_resume_dlg();
/* !prototypes */

#endif /* __UI_H */
