#ifndef __UPLOAD_H
#define __UPLOAD_H

#define SUBMIT_LIST 0
#define UPDATE_LIST 1
#define BUILD_LIST 2

typedef struct {
   int index, id, layer, protection_bit, bitrate_index, frequency;
   int padding_bit, private_bit, mode, mode_ext, copyright, original;
   int emphasis;
} MP3Header;

typedef struct {
   char *filename;
   char *checksum;
   unsigned long filesize;
   unsigned short frequency;
   unsigned short bitrate;
   time_t time;
   time_t mtime;
} MP3Stats;

typedef struct {
   time_t mtime;
   char *file;
} ShareFileEntry;

char *get_checksum(int, unsigned long);
char *conv_win(char *);
char *conv_unix(char *);
GList *list_match(GList *, char *);
void build_pipe_stop(int);
void build_pipe_read(gpointer, int, GdkInputCondition);
void setup_build_dlg(FILE *, char *, int, GList *);
void remove_slash(char *);
FILE *open_shared(char *);
char *path_get_file(char *);
char *path_get_dir(char *);
GList *upload_find(char *);
void upload_add(MP3Stats *);
void mp3_list_unlink(MP3Stats *);
int shared_list_handle(char *, int);

#endif /* __UPLOAD_H */
