#ifndef __UTILS_H
#define __UTILS_H

#define UNUSED(x) x=x

char *true_id(char *);
void j_error(char *, ...);
char *trunc_file(char *);
void log_add_hooks(char *, ...);
GList *remove_nick(GList *, char *);
int cancels();
int cancels_inc(int);
int connected();
int connecting();
int searching();
int browsing();
int safe_exit();
char *global_path(char *, char *);
char *local_path(char *, char *);
void unlink_log();
int is_comment(char *text);
char *hack_n(char *);
char *hack_chr(char *, char);
void read_file_free(GList *);
GList *read_file_full(const char *file, int line, FILE *f, int);
GList *read_file(const char *file, int line, FILE *f);
GList *read_file_with_n(const char *file, int line, FILE *f);
size_t struct_size(int t);
int get_type(void *data);
void set_type(void *data, int t);
char *all_lower(char *s);
void conv_file(char *s);
int file_exists(char *file);
char *next_arg_full_max_length(char *s, char **next, char end, int max);
char *next_arg_full(char *s, char **next, char end);
char *next_arg_first(char *s, char **next, char **first);
char *next_arg(char *s, char **next);
char *last_arg(char *s, char **next);
void convert(char *s, char *type, void *c);
long my_atol(const char *nptr);
int my_atoi(const char *nptr);
char *simplify_size(unsigned long int size);
void mp3_list_free();
void file_entry_free(void *data);
void theme_free(void *data);
void hook_free(void *data);
void property_free(void *data);
void transfer_free(void *data);
void mp3_free(void *data);
void search_free(void *data);
void server_free(void *data);
void user_free(void *data);
void channel_free(void *data);
void resume_free(void *data);
void gnapster_destroy(gpointer data);
int same_color(GdkColor col1, GdkColor col2);
void create_priv_dir();
FILE *open_log(char *file, char *flags);
void console_log(char *hook, char *text);

#endif /* __UTILS_H */
